# -*- coding: utf-8 -*-
first_name = '' # TODO
last_name = '' # TODO
hand_in = False # TODO: set to True and run again before hand_in. Hand_in also the output* file

import sys
import os
if hand_in:
    filename = os.path.basename(__file__).split('.')[0]
    output = open(f'output_{filename}_{last_name}_{first_name}.txt', 'w')
    sys.stdout = output
    print(f"{filename}\n {last_name}, {first_name}")

import matplotlib.pyplot as plt
import scipy.integrate
import numpy as np

from gauss_legendre_rule import gauss_legendre_rule


def trapezoidal(f, left, right, N, args=()):
    r"""
    Trapezoidal quadrature of function f from left to right with N subintervals.

    f:            Function f(x)
    left, right:  Bounds of the integration interval
    N:            Number of subintervals
    """


    # TODO vervollständigen Sie das Template.

    return 0.0 # Bitte ersetzen.


def midpoint(f, left, right, N, args=()):
    """Integrate f, over [left, right], using the midpoint rule.

    f     : function to integrate
    left  : left end
    right : right end
    N     : number of subintervals
    """

    # TODO vervollständigen Sie das Template.

    return 0.0 # Bitte ersetzen.


def simpson(f, left, right, N, args=()):
    r"""Integrate f, over [left, right], using Simpson quadrature.

    Note: this method uses 2*N+1 function evaluations.

    f     : function to integrate
    left  : left end
    right : right end
    N     : number of subintervals
    """

    # TODO vervollständigen Sie das Template.

    return 0.0 # Bitte ersetzen.


def gauss_legendre(f, left, right, n, args=()):
    r"""Integrate f, over [left, right], using Gauss-Legendre quadrature.

    f       : function to integrate
    left    : left end
    right   : right end
    n       : degree of the quadrature rule
    """

    # TODO vervollständigen Sie das Template.

    return 0.0 # Bitte ersetzen.


def adaptive_quadrature(f, meshes, rtol=1e-6, abstol=1e-10):
    """Adaptive quadrature using trapezoid and Simpson rules

    f:       Function f(x)
    meshes:  List of meshes, finest last. (in/out parameter)
    rtol:    relative tolerance for termination
    abstol:  absolute tolerance for termination, necessary in case the exact
             integral value = 0, which renders a relative tolerance meaningless.
    """
    M = meshes[-1]  # the current mesh


    # TODO vervollständigen Sie das Template.

    return 0.0, meshes # Bitte ersetzen.



# TODO vervollständigen Sie das Template.

#  Es fehlt Code spezifisch für 1a).
def plot_meshes(meshes):
    M0 = meshes[0]
    plt.figure(figsize=(12, 8))
    plt.plot(M0, np.zeros_like(M0), "db")
    for i, M in enumerate(meshes):
        plt.plot(M, i * np.ones_like(M), "|r")

    plt.xlabel(r"$x$")
    plt.ylabel(r"Mesh refinement level")


def plot_mesh_size(meshes):
    plt.figure(figsize=(12, 8))
    plt.plot([len(M) for M in meshes], "-o")
    plt.xlabel(r"Mesh refinement level")
    plt.ylabel(r"Mesh size")



# TODO vervollständigen Sie das Template.

#  Es fehlt Code spezifisch für 1b).
